
/**
 * This class supports reading and writing of files. 
 * 
 * @author mrteen
 *
 */

import java.io.*;
import java.util.*;
// import javax.swing.filechooser.FileSystemView;

public class IOClass{
	
	
	File inputFile ;
	FileReader inreader ;
	File outputFile ;
	FileWriter output ;
	PrintWriter print;
	boolean canbeused; 
	/////////////////////////////////////////////////////
	/// Constructors               //////////////////////	
	/////////////////////////////////////////////////////
	public IOClass(){
		
		// System.out.println("Have made a IOClass Object");
	}
	
	
	public IOClass(String filenametouse) { 
		
		// 
		inputFile = new File(filenametouse);
		
		// BufferedReader reader = new BufferedReader(inreader);
		try{
			inreader = new FileReader(inputFile); 
			canbeused = true;
			System.out.println("inreader OK!");}
			catch(IOException e){ System.out.println(e) ; canbeused = false; }
		
		/**outputFile = new File("output.txt");
		
		try{
			output = new FileWriter(outputFile); 
			canbeused = true;
			print = new PrintWriter(new BufferedWriter(output));
			System.out.println("print OK");}
		catch(IOException e){System.out.println(e); canbeused = false;}
		*/
		
		
		//System.out.println("kommer hit");
		//does nothing for the moment ;)
		
		
	}
	
	
	
	
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	//// 			METODER FOR KLASSEN!! 								/////
	////																/////
	////																/////
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	
	
	
	/**
	 * skriver innserted inverted list arrey til fil. 
	 * Filnavn = frste instans i array. 
	 *  
	 * @return boolean false om det ikke gikk  lage fil, true om det gikk
	 */
	
public boolean skrivInvertertListetilFil(ArrayList array) {
		
		String filename="";
		String filnavn;
		if(((String) array.get(0))!= null){
			filnavn = (String)array.get(0);}
		else {filnavn=null;}
		
		boolean havegotagoodname=true; // for  se at navnet har kommet skikkelig inn..
		
		while(havegotagoodname){
			if(filnavn==null){
				System.out.println("Write in the name you want for your file here"); 
				InputStreamReader reader = new InputStreamReader(System.in);
				BufferedReader innleser = new BufferedReader(reader);
				havegotagoodname=false;
				try {
					filnavn = innleser.readLine();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.out.println("Try again!");
					havegotagoodname=true; 
				}
			if(!havegotagoodname){filename = filnavn;}
			
				} else {filename = filnavn; havegotagoodname = false;}
		} // end while 
		
		outputFile = new File(filename);
		try{
			output = new FileWriter(outputFile); 
			canbeused = true;
			print = new PrintWriter(new BufferedWriter(output));
			System.out.println("print OK");}
		catch(IOException e){System.out.println(e); canbeused = false;}
		
		// begynner  skrive ut til fil
		boolean returnvariabel = false;
		if(this.canbeused){
		int teller =1;
		System.out.println(
				"*************************************************" + "\n" + 
				"***  Effecting String ArrayList to Textfile *****" + "\n" + 
				"*************************************************"
				);
		
		while(teller<array.size()){
			
			String temp = ((String)array.get(teller)) + "\n";
			System.out.print(temp + " ");
			print.write(temp);
			
						
			if(teller%10 == 0){
				System.out.println();
			} 
			teller++;
			} // end while; 
		returnvariabel = true;
		} // end if can be used! 
		else {
			
			System.out.println("Gr ikke an  bruke IOClass n.. noe feil.. ");
			returnvariabel = false;
		}
		print.close();
		return returnvariabel;
	}
	/**
	 * printer ut med filnavn og mellomrom for hver tiende insert. 
	 * 
	 * @param array Arrayliste med det som skal inn i filen. 
	 * @param filnavn
	 */
	public void leggTilDenneArrayListTilUtFil(ArrayList array, String filnavn) {
		
		String filename="";
		
		boolean havegotagoodname=true; // for  se at navnet har kommet skikkelig inn..
		
		while(havegotagoodname){
			if(filnavn==null){
				System.out.println("Write in the name you want for your file here"); 
				InputStreamReader reader = new InputStreamReader(System.in);
				BufferedReader innleser = new BufferedReader(reader);
				havegotagoodname=false;
				try {
					filnavn = innleser.readLine();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.out.println("Try again!");
					havegotagoodname=true; 
				}
			if(!havegotagoodname){filename = filnavn;}
			
				} else {filename = filnavn; havegotagoodname = false;}
		} // end while 
		
		outputFile = new File(filename);
		try{
			output = new FileWriter(outputFile); 
			canbeused = true;
			print = new PrintWriter(new BufferedWriter(output));
			System.out.println("print OK");}
		catch(IOException e){System.out.println(e); canbeused = false;}
		
		
		if(this.canbeused){
		int teller =0;
		System.out.println(
				"*************************************************" + "\n" + 
				"***  Effecting String ArrayList to Textfile *****" + "\n" + 
				"*************************************************"
				);
		
		while(teller<array.size()){
			
			String temp = ((String)array.get(teller)) + "\n";
			System.out.print(temp + " ");
			print.write(temp);
			
						
			if(teller%10 == 0){
				System.out.println();
			} 
			teller++;
			} // end while; 
		} // end if can be used! 
		else {
			System.out.println("Gr ikke an  bruke IOClass n.. noe feil.. ");
		}
		print.close();
	}
	
	/**
	 * This Method should make it possible to read from a file and make a 
	 * arraylist. 
	 * 
	 * 
	 * @param filename The name of the file you want to extract from. ex: "output.txt"
	 * @return array List med alt som ligger i en fil. 
	 */
	public ArrayList lesInnFraFilFaaArrayList(String filename){
		ArrayList array = new ArrayList();
		
	
			// There is a Possibility that openground is null
			
			System.out.println(
					"*************************************************" + "\n" + 
					"***  Effecting Textfile to ArrayList        *****" + "\n" +
					"***  Filname = " + filename + "*******************" + "\n" +
					"*************************************************"				);
			
	// What should be done if both takouts is not null.. default. 
		if(filename!=null){
			// iniating the lokal variables. 
			
			// INPUTSTUFF!! 
			inputFile = new File(filename);
			
				// BufferedReader reader = new BufferedReader(inreader);
				try{
				inreader = new FileReader(inputFile); 
				canbeused = true;
				//System.out.println("inreader OK!");
				}
				catch(IOException e){ System.out.println(e) ; canbeused = false; }
		}
		if(canbeused==true){
			BufferedReader reader = new BufferedReader(inreader); 
				
				
			String innstreng;
			try {
				innstreng = reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.out.println("Frste innstreng gikk til helvete");
				innstreng =null; 
				}
				// System.out.println(innstreng);
			
			while(innstreng!=null){
				
				String[] ordinn = SentenceUtil.getWords(innstreng);
		        
				// HER KAN DET VRE PROBLEMER MED NOE GREIER!!! 
				for(int k=0;k<ordinn.length; k++){
					if(!(this.indexTerminIndexBase(ordinn[k], array))){
		        	array = this.leggtilPaRettPlassIArray(ordinn[k], array);
					}
		        }	
				try {
					innstreng = reader.readLine();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.out.println("IOClass: while 1 IO Exception i readFromFileGetArray  :" + e);
					innstreng =null; 
				
				
					
				}
				// System.out.println("Dette er innstreng n  :" + innstreng);
				
			}// end while
			
		}
			
		
			
		
	return array; 
//	 end metode. 
		}
	
	public ArrayList lesInnOrdFraKonsoll(){
		
		ArrayList wordlist = new ArrayList();
		InputStreamReader reader = new InputStreamReader(System.in);
		BufferedReader innleser = new BufferedReader(reader);
		
		String input=""; 
		
		System.out.println("***********************************************" + "\n" +
				   "** Input Panel                            *****" + "\n" +
				   "** Write X Words enter each time          *****" + "\n" +
				   "** Exit using exit or Exit                *****" + "\n" +
				   "***********************************************"); 
		System.out.print("Write here....:  "); 

		
		while(input!=null){
			
			try {
				input = (String)innleser.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.out.println("There is something wrong with what is read in");
				input="odd";
			}
			
			if(input.compareTo("exit")==0 || input.compareTo("Exit")==0){input =null; break;} 
			if(input.compareTo("odd")==0){	System.out.print("Do you wanna write this? Try again"); 
			}
			else{wordlist.add(input);}
		
		
	}	
		return wordlist;
		
	}
	
	
	public String[] getFolderFileList(String foldername){
		
		String[] stringliste = {new String("ingenting")};
		File filfolder = new File(foldername);
		if(filfolder.isDirectory()){
			stringliste = filfolder.list();
		}
		else{
			System.out.println("Foldername er ikke foldername, gjr igjen");
			
		}
		System.out.println("hvor mange filer det finnes i dir " + stringliste.length );
		return stringliste;
	}
	
	/**
	 * Metode som finner ut hvor i en allerede alfabetisk liste en ny insert skal settes. 
	 * 
	 * @param indexTerm String index som skal inn i listen
	 * @param innliste ArrayListen du skal legge indexTermet inn i!
	 * @return int Posisjonen som skal fylles av den nye inserten. 
	 */
	public ArrayList leggtilPaRettPlassIArray(String indexTerm, ArrayList innliste){
		 
		int storste;
		storste=0;
		if(innliste.size()==1){
			// System.out.println("nodeServer: insertSpaceForNewIndexTerm indexBasesize ==1");
			if((indexTerm.compareToIgnoreCase((String)(innliste.get(0))))<0){
				// legge til p plass nr 0
				innliste.add(0, indexTerm);
				return innliste; 
			}
			else{
				// legge til p plass nr 1
				innliste.add(1, indexTerm); 
				return innliste;}
		}
		else{
			for(int i=0; i<innliste.size(); i++){
				if((indexTerm.compareToIgnoreCase((String)(innliste.get(i))))<0){
					storste=i;
					// System.out.println("nodeServer: insertSpaceForNewIndexTerm early return");
					// legge til p riktig plass
					innliste.add(storste, indexTerm);
					return innliste;
					
				}
				
			}
			// System.out.println("IOClass" + minste + " " + storste);
			// legge til p slutten
			innliste.add(indexTerm); 
			return innliste; 
	}
	}
	
	public boolean indexTerminIndexBase(String indexTerm, ArrayList indexBase){
		boolean returnboo = false; 
			for(int i=0; i<indexBase.size(); i++){
				if((indexTerm.compareTo((String)(indexBase.get(i))))==0){
					returnboo = true; 
					break;
				}
				
		}
		return returnboo;
	}
	
	
public void skrivStringListetilFil(String[] stringlist, String filnavn) {
		
	boolean canbeusedl = true;	
	String temp; 
	File outputFilel = new File(filnavn);
	int stringarraystr = stringlist.length;
	
	try{
		output = new FileWriter(outputFilel); 
		print = new PrintWriter(new BufferedWriter(output));
	}
	catch(IOException e){System.out.println(e); canbeusedl = false;}
	
	if(canbeusedl){
	for(int i=0; i<stringarraystr; i++){
		temp = stringlist[i]; 
		print.write(temp + "\n");
	}
	}else{System.out.println("Kan ikke skrive ut fil: " + filnavn);}
	
	print.close();
		
		
			
		
	}
public String[] lesInnFraFilFaaStingliste(String filename){
	ArrayList array = new ArrayList();
	String[] stringlist; 
	boolean canbeusedl = true;
		// There is a Possibility that openground is null
		
		System.out.println(
				"*************************************************" + "\n" + 
				"***  Effecting Textfile to String[]        *****" + "\n" +
				"***  Filname = " + filename + "*******************" + "\n" +
				"*************************************************"				);
		
// What should be done if both takouts is not null.. default. 
	if(filename!=null){
		// iniating the lokal variables. 
		
		// INPUTSTUFF!! 
		inputFile = new File(filename);
		
			// BufferedReader reader = new BufferedReader(inreader);
			try{
			inreader = new FileReader(inputFile); 
			canbeusedl = true;
			System.out.println("inreader OK!");}
			catch(IOException e){ System.out.println(e) ; canbeusedl = false; }
	}
	if(canbeusedl==true){
		BufferedReader reader = new BufferedReader(inreader); 
			
			
		String innstreng;
		try {
			innstreng = reader.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("Frste innstreng gikk til helvete");
			innstreng =null; 
			}
			System.out.println(innstreng);
		
		while(innstreng!=null){
			array.add(innstreng);
			try {
				innstreng = reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.out.println("IOClass: while 1 IO Exception i readFromFileGetArray  :" + e);
				innstreng =null; 
			
			
				
			}
			// System.out.println("Dette er innstreng n  :" + innstreng);
			
		}// end while
	}
		stringlist = new String[array.size()];
		
		for(int jalla =0; jalla<stringlist.length; jalla++){
			stringlist[jalla] = (String)array.get(jalla);
		}
		return stringlist; 
		
 
	}
}
	
//////////////////////////////////////////////////////////
// gamle kodesnutter
//////////////////////////////////////////////////////////
/*

//Code to write to file
String text = textField.getText();
byte b[] = text.getBytes();
String outputFileName =
System.getProperty("user.home",
File.separatorChar + "home" +
File.separatorChar + "monicap") +
File.separatorChar + "text.txt";
File outputFile = new File(outputFileName);
FileOutputStream out = new
FileOutputStream(outputFile);
out.write(b);
out.close();
//Code to read from file
String inputFileName =
System.getProperty("user.home",
File.separatorChar + "home" +
File.separatorChar + "monicap") +
File.separatorChar + "text.txt";
File inputFile = new File(inputFileName);
FileInputStream in = new
FileInputStream(inputFile);
byte bt[] = new
byte[(int)inputFile.length()];
in.read(bt);
s = new String(bt);
in.close();
}catch(java.io.IOException e){
System.out.println("Cannot
}
Clear text field
textField.setText("");
Display text read from file
text.setText("Text retrieved
textField.setText(s);
button.setText("Click Again");
_clickMeMode = false;
} else {
Save text to file
text.setText("Text to save to
textField.setText("");
button.setText("Click Me");
_clickMeMode = true;

*/ 
/* int teller1=0; int teller2=0; int teller3=0;
	
	while(teller1<ltakeout1){
		if(innstreng!=null){
		array.add(innstreng);
		}
			try {
		innstreng = reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				// e.printStackTrace();
				System.out.println("T1,T2,T3!=0 andre innstreng");
				innstreng=null; 
		}
		teller1++;
	}
	while(teller2<spaces){
		try {
			innstreng = reader.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("T1,T2,T3!=0 tredje innstreng");
		}
		teller2++;
		innstreng=null;
	}
	while(teller3<ltakeout2){
		if(innstreng!=null){
		array.add(innstreng);}
		try {
			innstreng = reader.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("T1,T2,T3!=0 fjerde innstreng");
			innstreng = null; 
		}
		teller3++;
	}*/