



import java.util.*;
import java.util.Random;
// import java.math.*;

/**
 * Denne klassen skal inneholde metoder for  teste ut ting. Det var orginal ideen, men..
 * 
 * Denne klassen har som objekt  sette igang nettverket p alle mter. 
 * Nodelisten, delay, routingTabeller etc blir laget med hjelp av denne klassen. 
 * 
 * 
 * @author Morten Tvenning
 * @version 25 feb
 */
public class TestingMetoder {

	/////////////////////////////////////////////////////
	/// Constructors               //////////////////////	
	/////////////////////////////////////////////////////
	ArrayList nodeliste; 
	Random rand; 
	/**
	 * Constructor for initating a plain testingMethod class
	 * Makes a local ArrayList to use ;)
	 */	
	public TestingMetoder(){
		
		nodeliste = new ArrayList();
		
		}
	
	////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	//// 																/////
	////				CLASS METHOD'S!! 								/////
	////																/////
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	
	
	
	
	/**
	 * Metode for  skrive ut en arraylist. 
	 * 
	 * @param thelist the list of Strings! that you want printed.  
	 */
	public void printArrayList(ArrayList thelist){
		
		int listSize = thelist.size();
		int teller =0;
		
		while(teller+1<= listSize){
			
			System.out.println((String)thelist.get(teller));
			teller++;
		
		}
		
		
	}
	
	
	/** 
	 * Lager X antall noder og returnerer en liste med noder i ArrayList format.  
	 * <p>
	 * Lager en routingtabell insert for hver node. dette er den forrige noden, 
	 * slik at nettverket ogs er en lenket liste. 
	 * 
	 * @param numberOfNodes the number of nodes you want to make! 
	 * @return nodelist the finished list of nodes.  
	 */
	
	public ArrayList lageNoder(int numberOfNodes){
	
		int lastNodeInnodeListe=0;
		int teller=0; 
		ArrayList nodeListe = new ArrayList();
	
		while(teller-1 < numberOfNodes){
					
			if(nodeListe.size()==0){
				NodeKlient node = new NodeKlient("nodenr: 1");
				nodeListe.add(node); teller++;
			
				}
			else { //(nodeliste.size()>0)
				// System.out.println("kom hit n");
				lastNodeInnodeListe = nodeListe.size()-1;
				String nodenavn = "nodenr: "+(teller);
				NodeKlient node = new NodeKlient((NodeKlient)nodeListe.get(lastNodeInnodeListe), nodenavn);
				nodeListe.add(node);
				//kommentar til consoll
				//System.out.println("Mekket en node nr :" + teller); 
				teller++;
			//legger til en frste node i routingtable til node nr1! 
			if(nodeListe.size()==2)
				{((NodeKlient)nodeListe.get(0)).leggTilNabo((NodeKlient)nodeListe.get(1));}
			}
		}
		this.nodeliste = nodeListe;
		return nodeListe;
		
	} // end method
	
	/** Tester en nodeliste ved  skrive ut hele listen 
	 * til konsoll 
	 * 
	 * @param nodeListe containing nodeClient objects 
	 */
	public void printNavnPaaAlleNoder(ArrayList nodeListe){
	
		int teller=0;
		System.out.println("Antall noder i nodelisten: " + nodeListe.size()); 
	
	
		while((teller)<nodeListe.size()){
				// System.out.println(teller); 
				System.out.println(((NodeKlient)nodeListe.get(teller)).getNavn()); 
				teller++;
		}	
	
	} // end writeNameofNodeListObjects
	
	/** 
	 * Skriver ut lokal nodeliste til konsoll, nodelisten som akkurat n finnes i 
	 * testingMetoder lokale ArrayList
	 */
	public void localNodeNamesPrint(){
		
		int teller=0;
		System.out.println("Antall noder i nodelisten :" + this.nodeliste.size()); 
	
	
		while((teller)<this.nodeliste.size()){
				System.out.println(((NodeKlient)this.nodeliste.get(teller)).getNavn()); 
				teller++;
		}	
	
		
	}
	/**
	 * Lager en randomisert routingtabell for hver node i input arraylisten. 
	 * 
	 * @param locnodeListe the inputlist of nodeClients you want to add routingTableinserts to
	 * @param antNoderLeggesTilHver how many nodes you want added. 
	 */

	public void addNodesAtRandomToRoutingTables(ArrayList locnodeListe, int antNoderLeggesTilHver ){
		int antNoder = locnodeListe.size(); 
		
		rand = new Random(); 
		int teller=0; int i=0;
		System.out.println("\n"+"***********************************************" +
				"\n" + "Initiating randomizing of routingTable" +
				"\n" + "Antall som skal legges i hver er : " + antNoderLeggesTilHver +
				"\n" + "***********************************************"); 
		while(i<antNoderLeggesTilHver){
			//denne skal legge til en for hver node for hvor mange ganger::... -->
			
			
			while(teller<antNoder){
				NodeKlient node  = (NodeKlient)locnodeListe.get(teller);
				
				int random = rand.nextInt(antNoder);
				// System.out.println(random);
				boolean whileNotTrue = true; 
					// finner ut om noden allerede finnes, og at det m lages en ny. 
					
					while (whileNotTrue){
						NodeKlient leggesTil = (NodeKlient)locnodeListe.get(random);
						if(node.nodeFinnesAlleredeIRT(leggesTil)){
							random = rand.nextInt(antNoder);
							leggesTil = (NodeKlient)locnodeListe.get(random);
							// System.out.println("Cannot add node, already exist!"); 
							}
						else{node.leggTilNabo(leggesTil); whileNotTrue = false;
							// System.out.println("Node : " + node.getName() + " adds " 
							// + leggesTil.getName()+ " to it's routingTable."); 
						}
					}
				// denne skal legge til en for hver node.. 
			// System.out.println(rand.nextInt(490));			
			teller++;
			
			
			}
			i++;
			teller=0; 
		}
	}
	
	/**
	 * Skriver ut alle noder og routingtabellene til konsoll. 
	 * 
	 * 
	 * @param liste the list of nodes you want printed, with their routingTables.
	 */
	public void printNodesogDeresRoutingTables(ArrayList liste){
		int listSize = liste.size();
		int teller=0;
		
		System.out.println("\n"+"***********************************************" +
				"\n" + "Printing Randomized RoutingTable for alle nodes" +
				"\n" + "Number of nodes in Topology : " + listSize +
				"\n" + "***********************************************");
		
		
		while(teller<listSize){
			((NodeKlient)liste.get(teller)).printRTtilKonsoll();
			teller++;
		}
	}
		
		/**
		 * 
		 * this method makes an array of String objects that contains all the nodes and their 
		 * routing tables. 
		 * 
		 * @param liste a list of nodes. 
		 * @return array List of String in ArrayList format
		 */
		
		public ArrayList lagEnArrayStringAvRTogNoder (ArrayList liste){
			int listSize = liste.size();
			int teller=0;
			int while2teller = 0;
			ArrayList array = new ArrayList();
			System.out.println("\n"+"***********************************************" +
					"\n" + "Getting an Array of all the Nodes and their RoutingTables" +
					"\n" + "Number of nodes in Topology : " + listSize +
					"\n" + "***********************************************");
			
			String standardinsertfornodes = "Nodename: ";  
			
			
			while(teller<listSize){

				ArrayList whilearray = ((NodeKlient)liste.get(teller)).getRoutingTable();
				String temp = standardinsertfornodes + ((NodeKlient)liste.get(teller)).getNavn() + "\n";
				array.add(temp);
				while2teller=0;
				temp = "The RoutingTable for This Array Looks Like this!";
				array.add(temp);
				// System.out.println( ((nodeClient)liste.get(teller)).getName());
				
				while(while2teller<whilearray.size()){
					//System.out.print("while2" + while2teller);
									
					if(whilearray.get(0) !=null){
						// System.out.println("Kommer .. whilearray er ikke tom");
						NodeKlient tempnode = ((NodeKlient)whilearray.get(while2teller));
						
						array.add((String)tempnode.getNavn());
						
					}
					else{ System.out.println("FaTALT NOE FEIL FOR I HELVETE!!");
						}
					
					
					
					
					while2teller++;

				}
				teller++;
				//System.out.println("\n");
				}
			return array;
				
}
	
	/**
	 * Skriver ut indekstermene for alle nodene. 
	 * 
	 * @param nodeliste arrayliste med alle nodene i
	 */
	public void printIndeksTermerForAlleNoder(ArrayList nodeliste){
		int nodeListeSize = nodeliste.size();
		int teller=0;
		while(teller<nodeListeSize){
			((NodeTjener)((NodeKlient)nodeliste.get(teller)).getTjenerNode()).printThisList();
			teller++;
		}
		
	}
	/**
	 * Skriver ut alle nodenes pathToServer
	 * 
	 * @param nodeliste
	 */
	public void printNodePathForAlleNoder(ArrayList nodeliste){
		for(int i=0; i<nodeliste.size(); i++){
			((NodeKlient)nodeliste.get(i)).printTjenerListe();
			
		}
		
	}
	/**
	 * setter delay fra random for alle noder. 1-100
	 * 
	 * @param nodeliste liste med alle nodene i systemet. 
	 */
	public void settLatencyForAlleNoder(ArrayList nodeliste){
		
		for(int i=0; i<nodeliste.size(); i++){
			
			((NodeKlient)nodeliste.get(i)).setLatency(rand.nextInt(100));
			// System.out.println("Nodedelay: " + ((nodeClient)nodeliste.get(i)).getDelay());
		}
	
	
		
		
	}
	/**
	 * Regner ut gjennomsnittet av delayene til server for alle nodene
	 * sum av alle noders delay / summen av noder. 
	 * 
	 * @param array nodelisten
	 * @return sumverdi gjennomsnittet av alla delayer. 
	 */
	public int faaGjennomsnittetAvDelaysTilServer(ArrayList array){
		int returnvalue;
		int sumverdi=0;
		for(int i=0; i< array.size(); i++){
			sumverdi +=((NodeKlient)array.get(i)).getPathToTjenerLatency();
			
		}
		System.out.println("\n"+"***********************************************" +
				"\n" + "***** Regner n ut gjennomsnittet av delayen " +
				"\n" + "***** fra klient til nermeste server." +
				"\n" + "***********************************************");
		System.out.println("");
		System.out.println("Sumverdi " + sumverdi );
		returnvalue = sumverdi/array.size();
		
		return returnvalue;
	}
	
	public void lesInnFraDirktoryogDistribuer(String foldername){
		
//		 bruke IO til  returnere en liste filer med 
		
		IOClass IO = new IOClass();
		String[] stringlist = IO.getFolderFileList("testfiler/");
		/*
		for(int i =0; i< stringlist.length; i++){
			System.out.println(stringlist[i]);
		}*/
		
		int strnodeliste  = nodeliste.size();
		rand = new Random();
		ArrayList sendout = new ArrayList();
		for(int j=0; j<stringlist.length; j++){
			int nodenr = rand.nextInt(strnodeliste);
			sendout = IO.lesInnFraFilFaaArrayList("testfiler/" + stringlist[j]);
			sendout.add(0, stringlist[j]);
			((NodeKlient)nodeliste.get(nodenr)).faaInverertIndeksTillegg(sendout);
		}
		
		// sende filen til en klient? 
		// gjr dette s lange det er filer, alts File[].size(); 
		// distribuere til mange noder. kanskje bare starte en plass? 
		
		
	}
	
	public void genererTestResultat(String sokeordinn){
		System.out.println("Generer Test Resultat for " + sokeordinn);
		int antallnoder = nodeliste.size();
		NodeKlient testnode = (NodeKlient)nodeliste.get(1); 
		ArrayList testarray = testnode.getRoutingTable();
		int antalliroutingtable = testarray.size();
		IOClass IOobjekt = new IOClass();
		// forandre for  gjre filene mindre String[] outstlist= new String[antallnoder+8];
		String[] outstlist= new String[8];
		
		String sokeord = sokeordinn;
		// setter inn informasjon om nettet
		outstlist[0] = "Mortens Distribuerte Anonymiserte System Test resultat";
		outstlist[1] = "Antall noder: " + antallnoder + " og antall noder i routingtable :" + antalliroutingtable;
		outstlist[2] = "Skeordet er '" +sokeord+"'";
		int maxhopp =0;	int minhopp = 100;
		int maxsvar =0; int minsvar =0;
		ArrayList svarliste = new ArrayList();
		int gjennomsnittteller = 0;
		// forandre for  gjre output filene mindre String insertstring;
		for(int i=0; i<antallnoder; i++){
			svarliste = ((NodeKlient)nodeliste.get(i)).sokEtter(sokeord, 0);
			// insertstring = (String)svarliste.get(0) + " " + (svarliste.size()-1);
			// sjekker for max og min hopp!
			if(i==0){minsvar = (svarliste.size()-1);}
			if(maxsvar<(svarliste.size()-1)){
				maxsvar = (svarliste.size()-1);
			}
			if(minsvar>(svarliste.size()-1)){
				minsvar = (svarliste.size()-1);
			}
			if(Integer.parseInt((String)svarliste.get(0))<minhopp){
				minhopp =Integer.parseInt((String)svarliste.get(0));
			}
			if(Integer.parseInt((String)svarliste.get(0))>maxhopp){
				maxhopp = Integer.parseInt((String)svarliste.get(0));
			}
			
			//outstlist[i+3] = insertstring;
			gjennomsnittteller += Integer.parseInt((String)svarliste.get(0));
		}
		double gjennomsnitt = (double)gjennomsnittteller/antallnoder; 
		//forandret for  gjre filene mindre 
		/*outstlist[antallnoder+3] = "Ca. gjennomsnitt hopp i hele tall er: " + gjennomsnitt;
		outstlist[antallnoder+4] = "Maks avstand   fra Klient til Server er: " + maxhopp;
		outstlist[antallnoder+5] = "Minste avstand fra Klient til Server er: " + minhopp;
		outstlist[antallnoder+6] = "Minstesvarantall er :  " +minsvar;
		outstlist[antallnoder+7] = "Strsteantall svar er: " +maxsvar;*/
		outstlist[3] = "Ca. gjennomsnitt hopp i hele tall er: " + gjennomsnitt;
		outstlist[4] = "Maks avstand   fra Klient til Server er: " + maxhopp;
		outstlist[5] = "Minste avstand fra Klient til Server er: " + minhopp;
		outstlist[6] = "Minstesvarantall er :  " +minsvar;
		outstlist[7] = "Strsteantall svar er: " +maxsvar;
		IOobjekt.skrivStringListetilFil(outstlist, ("testresultat/"+sokeord+antallnoder+".txt"));
	}
	
	public boolean testForBrukbarhet(){
		boolean testresultat = true;
		for(int i=0;i<nodeliste.size(); i++){
			// System.out.println(""+i);
			if(((NodeKlient)((NodeKlient)nodeliste.get(i)).getPathNodeTilTjener()) == null){
				testresultat = false;
			}
		}
		
		return testresultat; 
	}
} // end class

///////////////////////////////////////////////////////
//// Gamle kode snutter. 
///////////////////////////////////////////////////////

/*
 * 	/**
	 * Method for making a index wordlist, uses strengListeMekke class.
	 * 
	 * 
	 * @return indexOrdListe a finished list of words in ArrayListFormat 
	 
	public ArrayList makeIndexWordList(){

	strengListeMekker minListe = new strengListeMekker();
	ArrayList indexOrdListe = minListe.getList();
	return indexOrdListe;

	}

*/
